/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.SecretariaDAO;
import com.rjconsultores.ventaboletos.entidad.CuponSecretaria;
import com.rjconsultores.ventaboletos.entidad.Secretaria;
import com.rjconsultores.ventaboletos.service.SecretariaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("secretariaService")
public class SecretariaServiceImpl implements SecretariaService {

    @Autowired
    private SecretariaDAO secretariaDAO;

    public List<Secretaria> obtenerTodos() {
        return secretariaDAO.obtenerTodos();
    }

    public Secretaria obtenerID(Integer id) {
        return secretariaDAO.obtenerID(id);
    }

    @Transactional
    public Secretaria suscribir(Secretaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return secretariaDAO.suscribir(entidad);
    }

    @Transactional
    public Secretaria actualizacion(Secretaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return secretariaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Secretaria entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        for (CuponSecretaria cd : entidad.getLsCuponSecretaria()) {
            cd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            cd.setFecmodif(Calendar.getInstance().getTime());
            cd.setActivo(Boolean.FALSE);
        }

        secretariaDAO.actualizacion(entidad);
    }

    public List<Secretaria> buscar(String descsecretaria, String cvesecretaria) {
        return secretariaDAO.buscar(descsecretaria, cvesecretaria);
    }

    public List<Secretaria> buscar(String descsecretaria) {
         return secretariaDAO.buscar(descsecretaria);
    }

	@Override
	public Secretaria buscarSecretariaVoucherRod(Short formaPagoId) {
		return secretariaDAO.buscarSecretariaVoucherRod(formaPagoId);
	}
	
    public List<Secretaria> buscaLike(String descsecretaria) {
        return secretariaDAO.buscaLike(descsecretaria);
   }

}
